/*
*
* Eylonap_MultiCommands
* by: Eylonap (AuToPrO)
*
*/

#pragma semicolon 1

#define DEBUG

#define PLUGIN_AUTHOR "Eylonap (AuToPrO)"
#define PLUGIN_VERSION "1.0.2"

#include <sourcemod>
#include <sdktools>
#include <cstrike>
#include <sdkhooks>
#include <eylonap_mcommands>
#include <geoip>

/* 
[x] Eylonap_MultiCommands 
{
	[x] 1up
	[x] sethp
	[x] give weapon
	[x] admins
	[x] team
	[x] disarm
	[x] god
	[x] rr
	[x] swap
	[x] respawn
	[x] teleport
	[x] connect message
	[x] fexec
	[x] dropslot
	[x] bury
	[x] unbury
	[x] bring
	[x] speed
	[x] spec
	[x] shutdown
}
*/

ConVar adminsmod = null, connectmessage = null;

public Plugin myinfo = 
{
	name = "Eylonap_MultiCommands", 
	author = PLUGIN_AUTHOR, 
	description = "", 
	version = PLUGIN_VERSION, 
	url = ""
};

public OnPluginStart()
{
	//Admins Commands
	RegAdminCmd("sm_teleport", cmd_teleport, ADMFLAG_BAN);
	RegAdminCmd("sm_swap", cmd_swap, ADMFLAG_BAN);
	RegAdminCmd("sm_respawn", cmd_respawn, ADMFLAG_BAN);
	RegAdminCmd("sm_rr", cmd_rr, ADMFLAG_BAN);
	RegAdminCmd("sm_1up", cmd_1up, ADMFLAG_BAN);
	RegAdminCmd("sm_hp", cmd_hp, ADMFLAG_BAN);
	RegAdminCmd("sm_give", cmd_giveweapon, ADMFLAG_BAN);
	RegAdminCmd("sm_disarm", cmd_disarm, ADMFLAG_BAN);
	RegAdminCmd("sm_team", cmd_team, ADMFLAG_BAN);
	RegAdminCmd("sm_god", cmd_god, ADMFLAG_BAN);
	RegAdminCmd("sm_dropslot", cmd_dropslot, ADMFLAG_BAN);
	RegAdminCmd("sm_bury", cmd_bury, ADMFLAG_BAN);
	RegAdminCmd("sm_unbury", cmd_unbury, ADMFLAG_BAN);
	RegAdminCmd("sm_bring", cmd_bring, ADMFLAG_BAN);
	RegAdminCmd("sm_speed", cmd_speed, ADMFLAG_BAN);
	RegAdminCmd("sm_spec", cmd_spec, ADMFLAG_BAN);
	
	//Root Commands
	RegAdminCmd("sm_fexec", cmd_fexec, ADMFLAG_ROOT);
	RegAdminCmd("sm_shutdown", cmd_shutdown, ADMFLAG_ROOT);
	
	//Players Commands
	RegConsoleCmd("sm_admins", cmd_admins);
	
	//Cvars
	adminsmod = CreateConVar("eylonap_admin_mod", "1", "Choose your admin mod 0 - disable, 1 - menu, 2 - chat");
	connectmessage = CreateConVar("eylonap_connectmessage", "1", "0 - disable, 1 - enable");
}

public void OnClientPutInServer(int client)
{
	if (connectmessage.IntValue == 1)
	{
		char authid[64], ip[99], country[99];
		GetClientAuthId(client, AuthId_Steam2, authid, sizeof(authid));
		GetClientIP(client, ip, sizeof(ip), true);
		if (!GeoipCountry(ip, country, sizeof country))
		{
			country = "Unknown Country";
		}
		Eylonap_PrintToChatAll("\x0C%N \x09[%s] \x04connected to the server from [%s]", client, authid, country);
	}
}

public Action cmd_shutdown(int client, int args)
{
	if (args != 1)
	{
		Eylonap_PrintToChat(client, "Usage: sm_shutdown <time>");
		return Plugin_Handled;
	}
	char arg1[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	float time = StringToFloat(arg1);
	Eylonap_ShutDown(time);
	Eylonap_PrintToChatAll("%N shutdown the server in %0.1f sec", client, time);
	return Plugin_Handled;
}

public Action cmd_spec(int client, int args)
{
	if (args != 1)
	{
		Eylonap_PrintToChat(client, "Usage: sm_spec <target>");
		return Plugin_Handled;
	}
	char arg1[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	int target1[MAXPLAYERS + 1];
	char target_name[64];
	bool tn_is_ml;
	int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_CONNECTED, target_name, 64, tn_is_ml);
	if (!target_count)
	{
		Eylonap_PrintToChat(client, "Invalid Target");
		return Plugin_Handled;
	}
	for (int i = 0; i < target_count; i++)
	{
		if (Eylonap_CanTarget(client, target1[i]))
			Eylonap_ChangeTeam(target1[i], 1);
		else
			Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
	}
	Eylonap_PrintToChatAll("%s was moved by %N to spectator`s team", target_name, client);
	return Plugin_Handled;
}

public Action cmd_speed(int client, int args)
{
	if (args != 2)
	{
		Eylonap_PrintToChat(client, "Usage: sm_speed <target> <speednum>");
		return Plugin_Handled;
	}
	char arg1[32], arg2[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	GetCmdArg(2, arg2, sizeof(arg2));
	float speed = StringToFloat(arg2);
	if (!speed)
	{
		Eylonap_PrintToChat(client, "Invalid Speed Count");
		return Plugin_Handled;
	}
	int target1[MAXPLAYERS + 1];
	char target_name[64];
	bool tn_is_ml;
	int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_CONNECTED, target_name, 64, tn_is_ml);
	if (!target_count)
	{
		Eylonap_PrintToChat(client, "Invalid Target");
		return Plugin_Handled;
	}
	for (int i = 0; i < target_count; i++)
	{
		if (Eylonap_CanTarget(client, target1[i]))
			Eylonap_SetSpeed(target1[i], speed);
		else
			Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
	}
	Eylonap_PrintToChatAll("%N has set %0.1f speed for %s", client, speed, target_name);
	return Plugin_Handled;
}

public Action cmd_bring(int client, int args)
{
	if (args < 1)
	{
		Eylonap_PrintToChat(client, "Usage: sm_bring <target>");
		return Plugin_Handled;
	}
	char arg1[32];
	float pos[3], temppos[3], tpos[3], tang[3];
	GetCmdArg(1, arg1, sizeof(arg1));
	int target1[MAXPLAYERS + 1];
	char target_name[64];
	bool tn_is_ml;
	int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_CONNECTED, target_name, 64, tn_is_ml);
	if (!target_count)
	{
		Eylonap_PrintToChat(client, "Invalid Target");
		return Plugin_Handled;
	}
	for (int i = 0; i < target_count; i++)
	{
		if (Eylonap_CanTarget(client, target1[i]))
		{
			GetClientEyePosition(client, tpos);
			GetClientEyeAngles(client, tang);
			if (TR_DidHit(TR_TraceRayFilterEx(tpos, tang, MASK_SOLID, RayType_Infinite, entityfilter)))
				TR_GetEndPosition(temppos, TR_TraceRayFilterEx(tpos, tang, MASK_SOLID, RayType_Infinite, entityfilter));
			pos[0] = temppos[0];
			pos[1] = temppos[1];
			pos[2] = (temppos[2] + 4);
			Eylonap_TeleportClientToPos(target1[i], pos[0], pos[1], pos[2]);
		}
		else
			Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
	}
	Eylonap_PrintToChatAll("%s was teleported by %N to %0.02f %0.02f %0.02f", target_name, client, pos[0], pos[1], pos[2]);
	return Plugin_Handled;
}

public bool entityfilter(entity, contentsMask)
{
	return entity > MaxClients;
}

public Action cmd_unbury(int client, int args)
{
	if (args < 1)
	{
		Eylonap_PrintToChat(client, "Usage: sm_unbury <target>");
		return Plugin_Handled;
	}
	char arg1[32];
	float pos[3];
	GetCmdArg(1, arg1, sizeof(arg1));
	int target1[MAXPLAYERS + 1];
	char target_name[64];
	bool tn_is_ml;
	int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_CONNECTED, target_name, 64, tn_is_ml);
	if (!target_count)
	{
		Eylonap_PrintToChat(client, "Invalid Target");
		return Plugin_Handled;
	}
	for (int i = 0; i < target_count; i++)
	{
		if (Eylonap_CanTarget(client, target1[i]))
		{
			GetClientAbsOrigin(target1[i], pos);
			pos[2] += 30;
			Eylonap_TeleportClientToPos(target1[i], pos[0], pos[1], pos[2]);
		}
		else
			Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
	}
	Eylonap_PrintToChatAll("%N unbury %s", client, target_name);
	return Plugin_Handled;
}

public Action cmd_bury(int client, int args)
{
	if (args < 1)
	{
		Eylonap_PrintToChat(client, "Usage: sm_bury <target>");
		return Plugin_Handled;
	}
	char arg1[32];
	float pos[3];
	GetCmdArg(1, arg1, sizeof(arg1));
	int target1[MAXPLAYERS + 1];
	char target_name[64];
	bool tn_is_ml;
	int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_CONNECTED, target_name, 64, tn_is_ml);
	if (!target_count)
	{
		Eylonap_PrintToChat(client, "Invalid Target");
		return Plugin_Handled;
	}
	for (int i = 0; i < target_count; i++)
	{
		if (Eylonap_CanTarget(client, target1[i]))
		{
			GetClientAbsOrigin(target1[i], pos);
			pos[2] -= 30;
			Eylonap_TeleportClientToPos(target1[i], pos[0], pos[1], pos[2]);
		}
		else
			Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
	}
	Eylonap_PrintToChatAll("%N bury %s", client, target_name);
	return Plugin_Handled;
}

public Action cmd_dropslot(int client, int args)
{
	if (args < 2)
	{
		Eylonap_PrintToChat(client, "Usage: sm_dropslot <target> <slotnum>");
		return Plugin_Handled;
	}
	char arg1[32], arg2[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	GetCmdArg(2, arg2, sizeof(arg2));
	int slot = StringToInt(arg2);
	slot--;
	if (!slot && slot != 0)
	{
		Eylonap_PrintToChat(client, "Invalid Slotnum");
		return Plugin_Handled;
	}
	int target1[MAXPLAYERS + 1];
	char target_name[64];
	bool tn_is_ml;
	int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_CONNECTED, target_name, 64, tn_is_ml);
	if (!target_count)
	{
		Eylonap_PrintToChat(client, "Invalid Target");
		return Plugin_Handled;
	}
	for (int i = 0; i < target_count; i++)
	{
		if (Eylonap_CanTarget(client, target1[i]))
			Eylonap_DropSlot(target1[i], slot);
		else
			Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
	}
	Eylonap_PrintToChatAll("%N drop %d slot for %s", client, ++slot, target_name);
	return Plugin_Handled;
}

public Action cmd_fexec(int client, int args)
{
	if (args < 2)
	{
		Eylonap_PrintToChat(client, "Usage: sm_fexec <target> <cmd>");
		return Plugin_Handled;
	}
	char arg1[32], args2[32], argstring[250];
	GetCmdArg(1, arg1, sizeof(arg1));
	for (int i = 2; i <= args; i++)
	{
		GetCmdArg(i, args2, sizeof(args2));
		if (i == 2)Format(argstring, sizeof(argstring), "%s", args2);
		else Format(argstring, sizeof(argstring), "%s %s", argstring, args2);
	}
	int target1[MAXPLAYERS + 1];
	char target_name[64];
	bool tn_is_ml;
	int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_CONNECTED, target_name, 64, tn_is_ml);
	if (!target_count)
	{
		Eylonap_PrintToChat(client, "Invalid Target");
		return Plugin_Handled;
	}
	for (int i = 0; i < target_count; i++)
	{
		if (Eylonap_CanTarget(client, target1[i]))
			FakeClientCommandEx(target1[i], argstring);
		else
			Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
	}
	return Plugin_Handled;
}

public Action cmd_admins(int client, int args)
{
	if (adminsmod.IntValue != 1 && adminsmod.IntValue != 2)
		Eylonap_PrintToChat(client, "Feature Disable");
	
	
	if (adminsmod.IntValue == 1)
	{
		char name[MAX_NAME_LENGTH];
		int num = 1;
		Menu adminslist = new Menu(adminslistcb);
		adminslist.SetTitle("Admins List:");
		for (int i = 1; i <= MaxClients; i++)
		{
			if (Eylonap_ValidClient(i) && Eylonap_CheckFlag(i, ADMFLAG_BAN))
			{
				Format(name, sizeof(name), "#%d - %N", num, i);
				adminslist.AddItem("-1", name);
				++num;
			}
		}
		if (num == 1)
			adminslist.AddItem("-1", "No admins online");
		
		adminslist.ExitButton = true;
		adminslist.Display(client, MENU_TIME_FOREVER);
	}
	
	if (adminsmod.IntValue == 2)
	{
		char name[2400];
		int num = 0;
		Format(name, sizeof(name), "Admins List: \x06");
		for (int i = 1; i <= MaxClients; i++)
		{
			if (Eylonap_ValidClient(i) && Eylonap_CheckFlag(client, ADMFLAG_BAN))
			{
				Format(name, sizeof(name), "%s %N,", name, i);
				++num;
			}
		}
		if (num == 0)
			Eylonap_PrintToChat(client, "No admins online");
		else
			Eylonap_PrintToChat(client, name);
		
	}
	
	return Plugin_Handled;
}

public int adminslistcb(Menu adminslist, MenuAction action, int client, int item)
{
	//Do Nothing
}

public Action cmd_god(int client, int args)
{
	if (args != 2)
	{
		Eylonap_PrintToChat(client, "Usage: sm_god <target> <0/1>");
		return Plugin_Handled;
	}
	char arg1[32], arg2[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	GetCmdArg(2, arg2, sizeof(arg2));
	int godtype = StringToInt(arg2);
	if (godtype != 1 && godtype != 0)
	{
		Eylonap_PrintToChat(client, "Invalid God-Type");
		return Plugin_Handled;
	}
	int target1[MAXPLAYERS + 1];
	char target_name[64];
	bool tn_is_ml;
	int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_CONNECTED, target_name, 64, tn_is_ml);
	if (!target_count)
	{
		Eylonap_PrintToChat(client, "Invalid Target");
		return Plugin_Handled;
	}
	for (int i = 0; i < target_count; i++)
	{
		if (Eylonap_CanTarget(client, target1[i]))
			Eylonap_SetGod(target1[i], godtype);
		else
			Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
	}
	Eylonap_PrintToChatAll("%N %s %s", client, godtype == 1 ? "set godmod for" : "remove godmod from", target_name);
	return Plugin_Handled;
}

public Action cmd_team(int client, int args)
{
	if (args != 2)
	{
		Eylonap_PrintToChat(client, "Usage: sm_team <target> <1/2/3>");
		return Plugin_Handled;
	}
	char arg1[32], arg2[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	GetCmdArg(2, arg2, sizeof(arg2));
	int team = StringToInt(arg2);
	if (team != 1 && team != 2 && team != 3)
	{
		Eylonap_PrintToChat(client, "Invalid Team");
		return Plugin_Handled;
	}
	int target1[MAXPLAYERS + 1];
	char target_name[64];
	bool tn_is_ml;
	int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_CONNECTED, target_name, 64, tn_is_ml);
	if (!target_count)
	{
		Eylonap_PrintToChat(client, "Invalid Target");
		return Plugin_Handled;
	}
	for (int i = 0; i < target_count; i++)
	{
		if (Eylonap_CanTarget(client, target1[i]))
			Eylonap_ChangeTeam(target1[i], team, true);
		else
			Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
	}
	Eylonap_PrintToChatAll("%s was moved by %N to %s team", target_name, client, team == 1 ? "spectator`s" : team == 2 ? "t`s" : "ct`s");
	return Plugin_Handled;
}

public Action cmd_disarm(int client, int args)
{
	if (args != 1)
	{
		Eylonap_PrintToChat(client, "Usage: sm_disarm <target>");
		return Plugin_Handled;
	}
	char arg1[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	int target1[MAXPLAYERS + 1];
	char target_name[64];
	bool tn_is_ml;
	int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_CONNECTED, target_name, 64, tn_is_ml);
	if (!target_count)
	{
		Eylonap_PrintToChat(client, "Invalid Target");
		return Plugin_Handled;
	}
	for (int i = 0; i < target_count; i++)
	{
		if (Eylonap_CanTarget(client, target1[i]))
			Eylonap_DisarmClient(target1[i]);
		else
			Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
	}
	Eylonap_PrintToChatAll("%s was disarmed by %N", target_name, client);
	return Plugin_Handled;
}

public Action cmd_giveweapon(int client, int args)
{
	if (args != 2)
	{
		Eylonap_PrintToChat(client, "Usage: sm_give <target> <weaponname>");
		return Plugin_Handled;
	}
	char arg1[32], arg2[32], weaponname[64];
	GetCmdArg(1, arg1, sizeof(arg1));
	GetCmdArg(2, arg2, sizeof(arg2));
	int target1[MAXPLAYERS + 1];
	char target_name[64];
	bool tn_is_ml;
	int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_CONNECTED, target_name, 64, tn_is_ml);
	if (!target_count)
	{
		Eylonap_PrintToChat(client, "Invalid Target");
		return Plugin_Handled;
	}
	if (StrContains(arg2, "weapon_", false) != -1)
		Format(weaponname, sizeof(weaponname), "%s", arg2);
	else
		Format(weaponname, sizeof(weaponname), "weapon_%s", arg2);
	
	for (int i = 0; i < target_count; i++)
	{
		if (Eylonap_CanTarget(client, target1[i]))
			GivePlayerItem(target1[i], weaponname);
		else
			Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
	}
	Eylonap_PrintToChatAll("%N give %s to %s", client, arg2, target_name);
	return Plugin_Handled;
}

public Action cmd_hp(int client, int args)
{
	if (args != 2)
	{
		Eylonap_PrintToChat(client, "Usage: sm_hp <target> <hp>");
		return Plugin_Handled;
	}
	char arg1[32], arg2[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	GetCmdArg(2, arg2, sizeof(arg2));
	int hp = StringToInt(arg2);
	if (!hp)
	{
		Eylonap_PrintToChat(client, "Invalid HP Count");
		return Plugin_Handled;
	}
	int target1[MAXPLAYERS + 1];
	char target_name[64];
	bool tn_is_ml;
	int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_CONNECTED, target_name, 64, tn_is_ml);
	if (!target_count)
	{
		Eylonap_PrintToChat(client, "Invalid Target");
		return Plugin_Handled;
	}
	for (int i = 0; i < target_count; i++)
	{
		if (Eylonap_CanTarget(client, target1[i]))
			SetEntityHealth(target1[i], hp);
		else
			Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
	}
	Eylonap_PrintToChatAll("%N has set %d health for %s", client, hp, target_name);
	return Plugin_Handled;
}

public Action cmd_1up(int client, int args)
{
	if (args != 1)
	{
		Eylonap_PrintToChat(client, "Usage: sm_1up <target>");
		return Plugin_Handled;
	}
	char arg1[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	int target1[MAXPLAYERS + 1];
	char target_name[64];
	bool tn_is_ml;
	int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_CONNECTED, target_name, 64, tn_is_ml);
	if (!target_count)
	{
		Eylonap_PrintToChat(client, "Invalid Target");
		return Plugin_Handled;
	}
	for (int i = 0; i < target_count; i++)
	{
		if (Eylonap_CanTarget(client, target1[i]) && !IsPlayerAlive(target1[i]))
			Eylonap_RespawnClient(target1[i], true);
		else
			Eylonap_PrintToChat(client, "You cant target %N or target not alive", target1[i]);
	}
	Eylonap_PrintToChatAll("%s was spawned by %N", target_name, client);
	return Plugin_Handled;
}

public Action cmd_rr(int client, int args)
{
	if (args < 1)
	{
		SetConVarInt(FindConVar("mp_restartgame"), 1);
		Eylonap_PrintToChatAll("%N restart the game", client);
		return Plugin_Handled;
	}
	char arg1[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	int time = StringToInt(arg1);
	if (time < 1)
	{
		Eylonap_PrintToChat(client, "Invalid Time");
		return Plugin_Handled;
	}
	if (time > 60)
	{
		time = 60;
	}
	SetConVarInt(FindConVar("mp_restartgame"), time);
	Eylonap_PrintToChatAll("%N restart the game for %d sec", client, time);
	return Plugin_Handled;
}

public Action cmd_respawn(int client, int args)
{
	if (args != 1)
	{
		Eylonap_PrintToChat(client, "Usage: sm_respawn <target>");
		return Plugin_Handled;
	}
	char arg1[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	int target1[MAXPLAYERS + 1];
	char target_name[64];
	bool tn_is_ml;
	int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_CONNECTED, target_name, 64, tn_is_ml);
	if (!target_count)
	{
		Eylonap_PrintToChat(client, "Invalid Target");
		return Plugin_Handled;
	}
	for (int i = 0; i < target_count; i++)
	{
		if (Eylonap_CanTarget(client, target1[i]))
			Eylonap_RespawnClient(target1[i]);
		else
			Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
	}
	Eylonap_PrintToChatAll("%N respawn %s", client, target_name);
	return Plugin_Handled;
}

public Action cmd_swap(int client, int args)
{
	if (args != 1)
	{
		Eylonap_PrintToChat(client, "Usage: sm_swap <target>");
		return Plugin_Handled;
	}
	char arg1[32];
	GetCmdArg(1, arg1, sizeof(arg1));
	int target1[MAXPLAYERS + 1];
	char target_name[64];
	bool tn_is_ml;
	int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_CONNECTED, target_name, 64, tn_is_ml);
	if (!target_count)
	{
		Eylonap_PrintToChat(client, "Invalid Target");
		return Plugin_Handled;
	}
	for (int i = 0; i < target_count; i++)
	{
		if (Eylonap_CanTarget(client, target1[i]))
			Eylonap_SwapTeam(target1[i], true);
		else
			Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
		
	}
	Eylonap_PrintToChatAll("%s was swaped by %N", target_name, client);
	return Plugin_Handled;
}

public Action cmd_teleport(int client, int args)
{
	if (args != 2 && args != 4)
	{
		Eylonap_PrintToChat(client, "Usage: sm_teleport <target> .to. <target>/<x> <y> <z>");
		return Plugin_Handled;
	}
	char arg1[32], arg2[32], arg3[32], arg4[32];
	if (args == 2)
	{
		GetCmdArg(1, arg1, sizeof(arg1));
		GetCmdArg(2, arg2, sizeof(arg2));
		int target1[MAXPLAYERS + 1];
		char target_name[64];
		bool tn_is_ml;
		int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_ALIVE, target_name, 64, tn_is_ml);
		int target2 = FindTarget(client, arg2, false, false);
		if (!target2 || !target_count)
		{
			Eylonap_PrintToChat(client, "Invalid Target");
		}
		for (int i = 0; i < target_count; i++)
		{
			if (Eylonap_CanTarget(client, target1[i]))
				Eylonap_TeleportClientToClient(target1[i], target2, false);
			else
				Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
		}
		Eylonap_PrintToChatAll("%s was teleported by %N to %N", target_name, client, target2);
	}
	
	if (args == 4)
	{
		GetCmdArg(1, arg1, sizeof(arg1));
		GetCmdArg(2, arg2, sizeof(arg2));
		GetCmdArg(3, arg3, sizeof(arg3));
		GetCmdArg(4, arg4, sizeof(arg4));
		int target1[MAXPLAYERS + 1];
		char target_name[64];
		bool tn_is_ml;
		int target_count = ProcessTargetString(arg1, client, target1, (MAXPLAYERS + 1), COMMAND_FILTER_ALIVE, target_name, 64, tn_is_ml);
		
		if (!target_count)
		{
			Eylonap_PrintToChat(client, "Invalid Target");
			return Plugin_Handled;
		}
		float x = StringToFloat(arg2);
		float y = StringToFloat(arg3);
		float z = StringToFloat(arg4);
		for (int i = 0; i < target_count; i++)
		{
			if (Eylonap_CanTarget(client, target1[i]))
				Eylonap_TeleportClientToPos(target1[i], x, y, z);
			else
				Eylonap_PrintToChat(client, "You cant target %N", target1[i]);
		}
		Eylonap_PrintToChatAll("%s was teleported by %N to %0.02f, %0.02f, %0.02f", target_name, client, x, y, z);
	}
	return Plugin_Handled;
} 