/*
*
* Eylonap_MultiCommands_functions
* by: Eylonap (AuToPrO)
*
*/

#pragma semicolon 1

#define DEBUG

#define PLUGIN_AUTHOR "Eylonap"
#define PLUGIN_VERSION "1.00"

#include <sourcemod>
#include <sdktools>
#include <cstrike>
#include <sdkhooks>
#include <eylonap_mcommands>

float deathpos[MAXPLAYERS][3];

public Plugin myinfo = 
{
	name = "Eylonap_MultiCommands_functions", 
	author = PLUGIN_AUTHOR, 
	description = "", 
	version = PLUGIN_VERSION, 
	url = ""
};

public APLRes AskPluginLoad2(Handle myself, bool late, char[] error, int err_max)
{
	CreateNative("Eylonap_TeleportClientToClient", Native_TeleportToClient);
	CreateNative("Eylonap_TeleportClientToPos", Native_TeleportToPos);
	CreateNative("Eylonap_PrintToChatAll", Native_PrintToChatAll);
	CreateNative("Eylonap_PrintToChat", Native_PrintToChat);
	CreateNative("Eylonap_CanTarget", Native_CanTarget);
	CreateNative("Eylonap_SwapTeam", Native_SwapTeam);
	CreateNative("Eylonap_RespawnClient", Native_RespawnClient);
	CreateNative("Eylonap_DisarmClient", Native_DisarmClient);
	CreateNative("Eylonap_ChangeTeam", Native_ChangeTeam);
	CreateNative("Eylonap_SetGod", Native_SetGod);
	CreateNative("Eylonap_ValidClient", Native_ValidClient);
	CreateNative("Eylonap_CheckFlag", Native_CheckFlag);
	CreateNative("Eylonap_DropSlot", Native_DropSlot);
	CreateNative("Eylonap_SetSpeed", Native_SetSpeed);
	CreateNative("Eylonap_ShutDown", Native_ShutDown);
	
	RegPluginLibrary("Eylonap");
	return APLRes_Success;
}

public void OnPluginStart()
{
	HookEvent("player_death", event_death);
}

public Action event_death(Event event, const char[] name, bool dB)
{
	int client = GetClientOfUserId(event.GetInt("userid"));
	GetClientAbsOrigin(client, deathpos[client]);
}

public Action timecb(Handle Timer)
{
	InsertServerCommand("quit");
	ServerExecute();
}

public int Native_ShutDown(Handle plugin, int numParams)
{
	float time = GetNativeCell(1);
	CreateTimer(time, timecb, INVALID_HANDLE);
}

public int Native_SetSpeed(Handle plugin, int numParams)
{
	int client = GetNativeCell(1);
	float speed = GetNativeCell(2);
	SetEntPropFloat(client, Prop_Send, "m_flLaggedMovementValue", speed);
}

public int Native_DropSlot(Handle plugin, int numParams)
{
	int client = GetNativeCell(1);
	int slot = GetNativeCell(2);
	int ent = GetPlayerWeaponSlot(client, slot);
	
	if (ent != -1)
		CS_DropWeapon(client, ent, true);
}

public int Native_CheckFlag(Handle plugin, int numParams)
{
	int client = GetNativeCell(1);
	int flag = GetNativeCell(2);
	
	if (CheckCommandAccess(client, "sm_admin", flag))
		return true;
	
	return false;
}

public int Native_ValidClient(Handle plugin, int numParams)
{
	int client = GetNativeCell(1);
	
	if (client >= 1 && client <= MaxClients && IsClientConnected(client) && IsClientInGame(client) && !IsFakeClient(client))
	{
		return true;
	}
	
	return false;
}

public int Native_SetGod(Handle plugin, int numParams)
{
	int client = GetNativeCell(1);
	int value = GetNativeCell(2);
	if (value == 1)
		value = 0;
	else
		value = 2;
	
	SetEntProp(client, Prop_Data, "m_takedamage", value, 1);
}

public int Native_ChangeTeam(Handle plugin, int numParams)
{
	int client = GetNativeCell(1);
	int team = GetNativeCell(2);
	bool savealive = GetNativeCell(3);
	
	if (savealive && !IsPlayerAlive(client))
		savealive = false;
	
	ChangeClientTeam(client, team);
	
	if (savealive)
		Eylonap_RespawnClient(client);
	
}

public int Native_DisarmClient(Handle plugin, int numParams)
{
	int client = GetNativeCell(1);
	for (int i = 0; i <= 5; i++)
	{
		int weapon = GetPlayerWeaponSlot(client, i);
		if (IsValidEntity(weapon))
			RemovePlayerItem(client, weapon);
	}
}

public int Native_RespawnClient(Handle plugin, int numParams)
{
	int client = GetNativeCell(1);
	bool pos = GetNativeCell(2);
	if (pos)
	{
		CS_RespawnPlayer(client);
		TeleportEntity(client, deathpos[client], NULL_VECTOR, NULL_VECTOR);
	}
	else CS_RespawnPlayer(client);
}

public int Native_SwapTeam(Handle plugin, int numParams)
{
	int client = GetNativeCell(1);
	bool savealive = GetNativeCell(2);
	if (savealive && !IsPlayerAlive(client))
		savealive = false;
	if (GetClientTeam(client) == CS_TEAM_CT)
		ChangeClientTeam(client, CS_TEAM_T);
	else if (GetClientTeam(client) == CS_TEAM_T)
		ChangeClientTeam(client, CS_TEAM_CT);
	else if (GetClientTeam(client) == CS_TEAM_SPECTATOR)
		ChangeClientTeam(client, CS_TEAM_T);
	if (savealive)
		CS_RespawnPlayer(client);
}

public int Native_CanTarget(Handle plugin, int numParams)
{
	int client = GetNativeCell(1), target = GetNativeCell(2);
	char authtarget[32];
	GetClientAuthId(target, AuthId_Steam2, authtarget, sizeof(authtarget));
	AdminId source_aid = GetUserAdmin(client), target_aid;
	if ((target_aid = FindAdminByIdentity(AUTHMETHOD_STEAM, authtarget)) == INVALID_ADMIN_ID || CanAdminTarget(source_aid, target_aid))
		return true;
	else return false;
}


public int Native_PrintToChat(Handle plugin, int numParams)
{
	char buffer[192];
	int written;
	FormatNativeString(0, 2, 2, sizeof(buffer), written, buffer);
	int client = GetNativeCell(1);
	PrintToChat(client, " %s %s", PREFIX, buffer);
}

public int Native_PrintToChatAll(Handle plugin, int numParams)
{
	char buffer[192];
	int written;
	FormatNativeString(0, 1, 2, sizeof(buffer), written, buffer);
	
	PrintToChatAll(" %s %s", PREFIX, buffer);
}

public int Native_TeleportToPos(Handle plugin, int numParams)
{
	float origin[3];
	int client = GetNativeCell(1);
	origin[0] = GetNativeCell(2);
	origin[1] = GetNativeCell(3);
	origin[2] = GetNativeCell(4);
	bool Angle = GetNativeCell(5);
	
	float anglepos[3];
	GetClientAbsAngles(client, anglepos);
	
	if (Angle == true)
		TeleportEntity(client, origin, anglepos, NULL_VECTOR);
	
	TeleportEntity(client, origin, NULL_VECTOR, NULL_VECTOR);
}

public int Native_TeleportToClient(Handle plugin, int numParams)
{
	int client = GetNativeCell(1);
	int target = GetNativeCell(2);
	bool Angle = GetNativeCell(3);
	
	float position[3];
	float anglepos[3];
	GetClientAbsOrigin(target, position);
	GetClientAbsAngles(client, anglepos);
	
	if (Angle == true)
		TeleportEntity(client, position, anglepos, NULL_VECTOR);
	
	TeleportEntity(client, position, NULL_VECTOR, NULL_VECTOR);
}
