/*
*
* Eylonap_MultiCommands include
* by: Eylonap (AuToPrO)
*
*/

#define PREFIX "\x07[Eylonap_MultiCommands]\x03"

#if defined _eylonap_included
#endinput
#endif
#define _eylonap_included

/**
 * Teleport client for a Client.
 *
 * @param client    	The client will be teleport for target.
 * @param target		The target will client teleport to him.
 * @param angels 		save or not the angles. 
 *
 */
native void Eylonap_TeleportClientToClient(int client, int target, bool angels = false);

/**
 * Teleport client for a pos(xyz).
 *
 * @param client    	The client will be teleport for target.
 * @param x		The x will client teleport to him.
 * @param y		The y will client teleport to him.
 * @param z		The z will client teleport to him.
 * @param angels 		save or not the angles. 
 *
 */
native void Eylonap_TeleportClientToPos(int client, float x, float y, float z, bool angels = false);

/**
 * Write To All Chat.
 *
 * @param text		your message. 
 *
 */
native void Eylonap_PrintToChatAll(const char[] text, any...);

/**
 * Write To Client Private Chat.
 *
 * @param client		Client Index.
 * @param text			your message. 
 *
 */
native void Eylonap_PrintToChat(int client, const char[] text, any...);

/**
 * Can target
 *
 * @param client		Client Index.
 * @param target		your test target. 
 *
 */
native bool Eylonap_CanTarget(int client, int target);

/**
 * Swap Client Team
 *
 * @param client		Client Index.
 * @param savealive		keep your client alive while switching team.
 *
 */
native void Eylonap_SwapTeam(int client, bool savealive = false);

/**
 * Respawn Client
 *
 * @param client		Client Index. 
 * @param pos			save death position.
 *
 */
native void Eylonap_RespawnClient(int client, bool pos = false);

/**
 * Disarm Client
 *
 * @param client		Client Index. 
 *
 */
native void Eylonap_DisarmClient(int client);

/**
 * Change Client Team
 *
 * @param client		Client Index. 
 * @param team			team number (1 = spec, 2 = t, 3 = ct).
 * @param savealive		keep your client alive while switching team.
 *
 */
native void Eylonap_ChangeTeam(int client, int team, bool savealive = false);

/**
 * Set God
 *
 * @param client		Client Index.
 * @param value			your god value (0 - off, 1 - on)
 *
 */
native void Eylonap_SetGod(int client, int value);

/**
 * Check users
 *
 * @param client		Client Index.
 *
 */
native bool Eylonap_ValidClient(int client);

/**
 * Check Flag Accses
 *
 * @param client		Client Index. 
 * @param flag			your check flag (ADMFLAG_#YOURFLAG).
 *
 */
native bool Eylonap_CheckFlag(int client, int flag);

/**
 * DropSlot Client
 *
 * @param client		Client Index. 
 * @param slot			Weapon Slot.
 *
 */
native void Eylonap_DropSlot(int client, int slot); 

/**
 * Set Client Speed
 *
 * @param client		Client Index. 
 * @param speed			Speed Value.
 *
 */
native void Eylonap_SetSpeed(int client, float speed); 

/**
 * ShutDown
 *
 * @param time		CountDown time. 
 *
 */
native void Eylonap_ShutDown(float time); 